#
#	PL.make	- Makefile for PL
#
#	Copyright  1989, Claris Corporation.
#
#	This is a sub-makefile, called recursively when ::AppleWorks.make is
#	executed.
#
#	All modules (including Driver, Scrap, Pict., SS, DB, etc.)
#	should have similar makefiles in their respective folders.
#
#	This makefile rebuilds the module object files as necessary and creates a
#	file containing the necessary steps to link this module with the rest of 
#	AppleWorksGS.  ::AppleWorks.make combines the link files from the modules
#	into a script which it executes to create an executable.

#--------------------------------------------------------------------------------
#	Variables

AsmIIGSOptions	=	

Segment1		=	PL
Segment2		=	PL2
Segment3		=	PLSCRAP

Module		=	PL
ModuleDir		=	{AWGS}{Module}:

SrcDir 		=	{ModuleDir}Src:
IncDir 		=	{ModuleDir}
ObjDir 		=	{ModuleDir}Obj:

GlobalIncludes =	{AWGS}Macros:Macros.dump	
				{IncDir}PL.equ			
				{AWGS}Driver:Driver.equ

Linkfile		=	{ModuleDir}{Module}.link
Makefile		=	{ModuleDir}{Module}.make

Objs			=	{Objs1} {Objs2} {Objs3}

Objs1		=	{objdir}pl.o			
				{objdir}pdata.o		
				{objdir}picon.o		
				{objdir}putil.o		
				{objdir}poptions.o		
				{objdir}pfile.o		
				{objdir}pprint.o		
				{objdir}ptool.o		
				{objdir}pmouse.o		
				{objdir}pobject.o		
				{objdir}pobjutil.o		
				{objdir}plist.o		
				{objdir}pmove.o		
				{objdir}ppage.o		
				{objdir}pruler.o		
				{objdir}pupdate.o		
				{objdir}pmenus.o		
				{objdir}pedit.o		
				{objdir}pundo.o		
				{objdir}parrange.o		
				{objdir}pscroll.o		
				{objdir}pguide.o		
				{objdir}pdrag.o		
				{objdir}ptab.o			
				{objdir}main.o			
				{objdir}prim.o			
				{objdir}prim2.o		
				{objdir}tutil.o		
				{objdir}tdraw.o		
				{objdir}click.o		
				{objdir}key.o			
				{objdir}edit.o			
				{objdir}format.o		
				{objdir}truler.o		
				{objdir}tcntl.o

Objs2		=	{objdir}pruler2.o		
				{objdir}putil2.o		
				{objdir}pobjutil2.o		
				{objdir}tscrap.o		
				{objdir}tutil2.o		
#				{objdir}tdbg.o			
#				{objdir}tdbg.o			
#				{objdir}pdbg.o			
#				{objdir}pdbg.o

Objs3		=	{objdir}pscrap.o		
				{objdir}strings.o

ScrapDpndtObj	=	{objdir}pedit.o		
				{objdir}pl.o

#--------------------------------------------------------------------------------
#	Main target

{Linkfile}		{Objs} {Makefile}
	@if "`newer {Makefile} {LinkFile}`";					
		@echo	"# Creating {LinkFile} "
		@echo	"	-lseg:dynamic		{Segment1}	{Objs1}	" >  {targ}
		@echo	"	-lseg:dynamic		{Segment2}	{Objs2}	" >> {targ}
		@echo	"	-lseg		{Segment3}	{Objs3}	" >> {targ}
	@else
		@touch {linkfile}
	@end

#	Global PL dependencies

{Objs}				{GlobalIncludes}

#	Other PL dependencies

{ScrapDpndtObj}		{AWGS}Scrap:Scrap.equ


clean	
	@confirm "Delete {Module} objs and linkfile?"
	@if ({status} == 0)
		set foobar {exit}
		unset exit
		delete -y {awgs}{module}:src:.lst
		delete -y {Linkfile}
		delete -y {Objs} 
		set exit {foobar}
	@end

#--------------------------------------------------------------------------------
#	Default rules

.o		.s
	AsmIIGS {DepDir}{Default}.s -i {IncDir},{AWGS}Macros,{AWGS}Driver,{AWGS}Scrap -o {TargDir}{Default}.o {AsmIIGSOptions}

{ObjDir}		{SrcDir}

