#
#	Pict.make	- Makefile for Pict
#
#	Copyright  1989, Claris Corporation.
#
#	This is a sub-makefile, called recursively when ::AppleWorks.make is
#	executed.
#
#	All modules (including Driver, Scrap, Pict., SS, DB, etc.)
#	should have similar makefiles in their respective folders.
#
#	This makefile rebuilds the module object files as necessary and creates a
#	file containing the necessary steps to link this module with the rest of 
#	AppleWorksGS.  ::AppleWorks.make combines the link files from the modules
#	into a script which it executes to create an executable.

#--------------------------------------------------------------------------------
#	Variables

AsmIIGSOptions	=	 

Segment1		=	PICT

Module		=	Pict
ModuleDir		=	{AWGS}{Module}:

SrcDir 		=	{ModuleDir}Src:
IncDir 		=	{ModuleDir}
ObjDir 		=	{ModuleDir}Obj:

Linkfile		=	{ModuleDir}{Module}.link
Makefile		=	{ModuleDir}{Module}.make

GlobalIncludes	=	{IncDir}Pict.equ			
				{AWGS}Driver:Driver.equ

GlobalMacros	=	{AWGS}Macros:Macros.dump


Objs			=	{ObjDir}picture.aii.o		
				{ObjDir}fliprot.aii.o		
				{ObjDir}region.aii.o		
				{ObjDir}pixels.aii.o		
				{ObjDir}text.aii.o			
				{ObjDir}misc.aii.o

#--------------------------------------------------------------------------------
#	Main target

{Linkfile}		{Objs} {Makefile}
		@echo	"Creating {LinkFile} "
		@echo	"	-lseg:dynamic		{Segment1}	{Objs}	" >  {Targ}

#	Global Pict dependencies

{Objs}			{GlobalIncludes} {GlobalMacros}
	

clean	
	@confirm "Delete {Module} objs and linkfile?"
	@if {status} == 0 then
		rm	{Linkfile} {Objs}
	@end

#--------------------------------------------------------------------------------
#	Default rules

.aii.o		.aii
	AsmIIGS -i {AWGS}Macros,{AWGS}Driver,{AWGS}Pict {DepDir}{Default}.aii -o {TargDir}{Default}.aii.o {AsmIIGSOptions}

{ObjDir}		{SrcDir}
