#
#	WP.make	- Makefile for WP
#
#	Copyright  1989, Claris Corporation.
#
#	This is a sub-makefile, called recursively when ::AppleWorks.make is
#	executed.
#
#	All modules (including Driver, Scrap, Pict., SS, DB, etc.)
#	should have similar makefiles in their respective folders.
#
#	This makefile rebuilds the module object files as necessary and creates a
#	file containing the necessary steps to link this module with the rest of
#	AppleWorksGS.  ::AppleWorks.make combines the link files from the modules
#	into a script which it executes to create an executable.

#--------------------------------------------------------------------------------
#	Variables

AsmIIGSOptions	=	-d Developing=0,ChangeBorders,Network={Network}

Segment1		=	WP
Segment2		=	WP2

Module		=	WP
ModuleDir		=	{AWGS}{Module}:

SrcDir 		=	{ModuleDir}Src:
IncDir 		=	{ModuleDir}
ObjDir 		=	{ModuleDir}Obj:

OldObjDir		=	{AWGS}WP:Old.Obj:

Linkfile		=	{ModuleDir}{Module}.link
Makefile		=	{ModuleDir}{Module}.make

GlobalIncludes	=	{AWGS}Driver:Driver.equ		
				{IncDir}WP.equ

GlobalMacros	=	{AWGS}macros:macros.dump		
				{IncDir}WP.macros

Objs			=	{Objs1} {Objs2}

SpellObj		=	{ObjDir}spell.aii.o

NoSpellObj	=	{ObjDir}spstub.aii.o

Objs1		=	{ObjDir}jumps.aii.o			
				{ObjDir}wpglobals.aii.o		
				{ObjDir}screen.aii.o		
				{ObjDir}docs.aii.o			
				{ObjDir}pars.aii.o			
				{ObjDir}lines.aii.o			
				{ObjDir}drawing.aii.o		
				{ObjDir}menus.aii.o			
				{ObjDir}editing.aii.o		
				{ObjDir}edit2.aii.o			
				{ObjDir}mouse.aii.o			
				{ObjDir}pages.aii.o			
				{ObjDir}pixel.aii.o			
				{ObjDir}fonts.aii.o			
				{ObjDir}arrows.aii.o		
				{ObjDir}delete.aii.o		
				{ObjDir}printing.aii.o		
				{ObjDir}wpfileio.aii.o		
				{ObjDir}paste.aii.o			
				{ObjDir}undo.aii.o			
				{ObjDir}tools.aii.o			
				{ObjDir}fr.dialog.aii.o		
				{ObjDir}fr.work.aii.o		
				{ObjDir}stats.aii.o			
				{ObjDir}copy.aii.o			
				{ObjDir}pmerge.aii.o		
				{ObjDir}mergedlg.aii.o		
				{ObjDir}report.aii.o		
				{ObjDir}memory.aii.o


Objs2		=	{ObjDir}dlgstuff.aii.o			
				{ObjDir}rulers.aii.o			
				{ObjDir}rulers2.aii.o			
				{ObjDir}pagedlg.aii.o


#--------------------------------------------------------------------------------
#	Main target

{Linkfile}		{Objs} {SpellObj} {Makefile}
	@if "`newer {Makefile} {LinkFile}`";					
		@echo	"# Creating {LinkFile} "
		@echo	"	-lseg:dynamic	{Segment1}	{Objs1} {SpellObj} " >  {Targ}
		@echo	"	-lseg	{Segment2}	{Objs2}		    " >> {Targ}
	@else
		@touch {linkfile}
	@end

{Linkfile}.nsp 	{Objs} {NoSpellObj} {Makefile}
	@if "`newer {Makefile} {LinkFile}.nsp`";					
		@echo	"# Creating {LinkFile}.nsp "
		@echo	"	-lseg:dynamic	{Segment1}	{Objs1} {NoSpellObj} " >  {Targ}
		@echo	"	-lseg		{Segment2}	{Objs2}			 " >> {Targ}
	@else
		@touch {linkfile}.nsp
	@end

#	Global CM dependencies

{Objs}			{GlobalIncludes}	{GlobalMacros}


clean	
	@confirm "Delete {Module} objs and linkfile?"
	@if {status} == 0 then
		rm	{Linkfile} {Objs}
	@end

#--------------------------------------------------------------------------------
#	Exceptions

{ObjDir}copy.aii.o		
{ObjDir}paste.aii.o			{AWGS}Scrap:Scrap.equ

{ObjDir}wpfileio.aii.o		{AWGS}WP:Wp.make

#--------------------------------------------------------------------------------
#	Default rules

.aii.o		.aii
	AsmIIGS {DepDir}{Default}.aii -o {TargDir}{Default}.aii.o  -i {IncDir},{AWGS}Macros,{AWGS}Driver,{AWGS}Scrap {AsmIIGSOptions}

{ObjDir}		{SrcDir}

